class audioGen implements Instrument {

  Oscil sine; 
  ADSR env; 
  //AudioOutput out;

  audioGen (float freq, float amp) {
    sine = new Oscil(freq, amp, Waves.SINE);
    env = new ADSR(/*maxAmp*/0.5, /*att*/0.01, /*dec*/0.01, /*suslvl*/0.5, /*rel*/0.1); 
    sine.patch(env);
  }

  void noteOn(float dur) {
    env.noteOn();
    env.patch(out);
  }
  void noteOff() {
    env.unpatchAfterRelease(out);
    env.noteOff();
  }
}

